require({cache:{
'url:epi-find/widget/templates/BoostingEditor.html':"﻿<div class=\"epi-boosting__sections  epi-boosting__editor-section\">\r\n    <div data-dojo-attach-point=\"propertiesGridNode\" class=\"epi-chromeless\"></div>\r\n    <div>\r\n        <input data-dojo-attach-point=\"submitButton\" type=\"submit\" data-dojo-type=\"dijit/form/Button\"\r\n               class=\"epi-primary\" />\r\n        <input data-dojo-attach-point=\"resetButton\" type=\"reset\" data-dojo-type=\"dijit/form/Button\" />\r\n        <input data-dojo-attach-point=\"resetToDefaultButton\" data-dojo-type=\"dijit/form/Button\"\r\n               class=\"epi-chromeless epi-visibleLink\" />\r\n    </div>\r\n    <p class=\"epi-help\">${i18n.help_weights}</p>\r\n</div>\r\n"}});
﻿define("epi-find/widget/BoostingEditor", [
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/dom-construct",
        "dojo/on",
        "dojo/dom-class",
        "dojo/when",

        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",

        "dijit/form/Button",
        "dijit/form/CheckBox",
        "dijit/form/HorizontalSlider",

        "dgrid/Grid",

        "put-selector/put",

        "dojox/mvc/at",

        "./WeightSelector",

        "epi-saas-base/widgets/_NotificationMixin",
        "epi-saas-base/widgets/_ActionButtonsMixin",

        "dojo/i18n!./nls/BoostingEditor",
        "dojo/text!./templates/BoostingEditor.html"
],
    function(declare,
            lang,
            domConstruct,
            on,
            domClass,
            when,
            _WidgetBase,
            _TemplatedMixin,
            _WidgetsInTemplateMixin,
            Button,
            CheckBox,
            HorizontalSlider,
            Grid,
            put,
            at,
            WeightSelector,
            _NotificationMixin,
            _ActionButtonsMixin,
            i18n,
            template) {

        // module:
        //      epi-find/widget/BoostingEditor

        return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _NotificationMixin, _ActionButtonsMixin], {
            // summary:
            //     Boosting weight editor.

            templateString: template,

            i18n: i18n,

            model: null,

            weightValues: null,

            postCreate: function() {
                this.inherited(arguments);

                this.submitButton.set("label", i18n.buttons_save);
                this.resetButton.set("label", i18n.buttons_cancel);
                this.resetToDefaultButton.set("label", i18n.buttons_resetToDefault);

                if (!this.model) {
                    throw "No model specified";
                }

                this.actionButtons = [
                    this.submitButton,
                    this.resetButton,
                    this.resetToDefaultButton
                ];

                this.enabledWhenNoChangesButtons = [
                    this.resetToDefaultButton
                ];

                if (!this.weightValues) {
                    this.weightValues = [0, 0.15, 0.5, 1, 1.5, 2];
                }

                var self = this, EditorGrid = declare([Grid, _NotificationMixin]);

                this.propertiesGrid = new EditorGrid({
                        i18n: i18n,
                        columns: [
                            {
                                label: " ",
                                sortable: false,
                                className: "epi-grid-column--checkbox",
                                renderCell: function(property, value, node) {
                                    var includedBox = new CheckBox({
                                        propertyWeight: at(self.model.weightsModel, property).direction(at.from).transform({
                                            format: function (weight) {
                                                includedBox.propertyPreviousWeight = includedBox.propertyWeight;
                                                return weight;
                                            }
                                        }),
                                        checked: at(self.model.weightsModel, property).transform({
                                            format: function(weight){
                                                return weight > 0;
                                            },
                                            parse: function(checked){
                                                return checked ?
                                                    includedBox.propertyPreviousWeight || includedBox.propertyWeight || 1 :
                                                    0;
                                            }
                                        })
                                    });
                                    self.own(includedBox);
                                    domConstruct.place(includedBox.domNode, node);
                                    includedBox.startup();
                                }
                            },
                            {
                                label: i18n.fields_name,
                                className: "epi-grid-header--h3",
                                sortable: false,
                                formatter: function (propertyName) {
                                    return i18n["properties_" + propertyName] || propertyName;
                                }
                            },
                            {
                                label: i18n.fields_weight,
                                sortable: false,
                                className: "epi-grid-header--h3",
                                renderCell: function(property, value, node) {
                                    var selector = new WeightSelector({
                                            value: at(self.model.weightsModel, property),
                                            values: self.weightValues
                                        });
                                    domConstruct.place(selector.domNode, node);
                                    selector.startup();
                                }
                            }
                        ]
                    }, this.propertiesGridNode);

                this.own(
                    this.propertiesGrid,
                    on(this.submitButton, "click", function(e) {
                        e.preventDefault();
                        e.stopPropagation();
                        self.indicateInProgress(self.submitButton);
                        when(self.model.commit(), function () {
                            self.showSuccess(i18n.savedMessage);
                            self.indicateSuccess();
                            self.reset();
                        }, function (error) {
                            self.showError(error, i18n.errorMessage);
                            self.indicateError();
                        });
                    }),
                    on(this.resetButton, "click", function(e) {
                        e.preventDefault();
                        e.stopPropagation();
                        self.model.reset();
                        self.reset();
                        self.refresh();
                    }),
                    on(this.resetToDefaultButton, "click", function(e) {
                        e.preventDefault();
                        e.stopPropagation();
                        self.model.setDefault();
                    }),
                    this.propertiesGrid.on("dgrid-error", function(error) {
                        self.propertiesGrid.showErrorInGrid(error);
                    }),
                    this.watchDataChanges([
                        this.model,
                        this.model.weightsModel])
                );
            },

            startup: function() {
                this.inherited(arguments);

                this.propertiesGrid.startup();
                this.refresh();
            },

            refresh: function(forceRefresh) {
                if (this.hasChanges && !forceRefresh) {
                    return;
                }
                when(this.model.refresh(), lang.hitch(this, function() {
                        this.propertiesGrid.refresh();
                        this.propertiesGrid.renderArray(this.model.propertyNames);

                        this.set("hasChanges", false);
                    }),
                    lang.hitch(this, function(error) {
                        this.propertiesGrid.showErrorInGrid(error);
                    })
                );
            },

            resize: function () {
                // We resize the grid in order to make sure that sizes of header, scroller, etc
                // are recalculated when it's needed, for instance, when grid becomes visible.
                this.propertiesGrid.resize();
            }
        });
    });
