require({cache:{
'url:epi-find/widget/templates/Configure.html':"﻿<div class=\"epi-pane  epi-pane--tools is-active epi-focused\">\r\n    <div class=\"epi-pane__content-wrapper\">\r\n        <div class=\"epi-pane__header\">\r\n            <h1>${i18n.header}</h1>\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n        </div>\r\n        <div data-dojo-attach-point=\"contentNode\" class=\"epi-pane__content\">\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n                <ul class=\"epi-pane__content__nav clearfix\">\r\n                    <li><a href=\"#\" title=\"${i18n.nav_boosting}\" class=\"epi-pane__content__header-link--boosting\" data-dojo-attach-point=\"boostingLink\">${i18n.nav_boosting}</a></li>\r\n                    <li><a href=\"#\" title=\"${i18n.nav_index}\" class=\"epi-pane__content__header-link--index\" data-dojo-attach-point=\"indexLink\">${i18n.nav_index}</a></li>\r\n                    <li><a href=\"#\" title=\"${i18n.nav_connectors}\" class=\"epi-pane__content__header-link--connectors\" data-dojo-attach-point=\"connectorsLink\">${i18n.nav_connectors}</a></li>\r\n                </ul>\r\n                <div data-dojo-type=\"dijit/layout/StackContainer\" data-dojo-attach-point=\"widgetContainer\" data-dojo-props=\"doLayout: false, isLayoutContainer: true\" class=\"epi-pane__content__content-container\"></div>\r\n        </div>\r\n    </div>\r\n</div>"}});
﻿define("epi-find/widget/Configure", [
        "dojo/_base/config",
        "dojo/_base/declare",
        "dojo/on",
        "dojo/topic",
        "dojo/dom-class",
        "dojo/query",

        "dijit/_WidgetBase",
        "dijit/_WidgetsInTemplateMixin",
        "dijit/_TemplatedMixin",
        "dijit/layout/ContentPane",
        "dijit/layout/StackContainer",

        "./_ActionableMixin",
        "./Connectors",
        "./Boosting",
        "./Index",

        "../AccessModel",

        "dojo/i18n!./nls/Configure",
        "dojo/text!./templates/Configure.html"
],
    function(config,
             declare,
             on,
             topic,
             domClass,
             query,
             _WidgetBase,
             _WidgetsInTemplateMixin,
             _TemplatedMixin,
             ContentPane,
             StackContainer,
             _ActionableMixin,
             Connectors,
             Boosting,
             Index,
             AccessModel,
             i18n,
             template) {

        // module:
        //      epi-find/widget/Connectors

        return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionableMixin], {
            // summary:
            //     Manage view.

            templateString: template,

            i18n: i18n,

            model: null,

            constructor: function() {
                this.inherited(arguments);
            },

            postCreate: function() {
                this.inherited(arguments);

                this.boostingWidget = new Boosting({
                    model: this.model,
                    disabledView: !AccessModel.isEnabled(config.intents.view.boosting),
                    scrollNode: this.contentNode
                });

                this.widgetContainer.addChild(this.boostingWidget);
                this.own(this.boostingWidget);

                this.indexWidget = new Index({
                    model: this.model.indexModel
                });

                this.widgetContainer.addChild(this.indexWidget);
                this.own(this.indexWidget);

                this.connectorsWidget = new Connectors({
                    model: this.model.connectorModel,
                    disabledView: !AccessModel.isEnabled(config.intents.view.connectors),
                    scrollNode: this.contentNode
                });

                this.widgetContainer.addChild(this.connectorsWidget);
                this.own(this.connectorsWidget);

                var self = this,
                   boostingAction = {
                        currentAction: "boosting",
                        takeAction: function(actions, params) {
                            self.widgetContainer.selectChild(self.boostingWidget);
                            self.boostingWidget.takeAction(actions, params);
                            self._switchSelection(self.boostingLink.parentNode);
                            return self.boostingWidget;
                        }
                    },
                    indexAction = {
                        currentAction: "index",
                        takeAction: function(actions, params) {
                            self.widgetContainer.selectChild(self.indexWidget);
                            self.indexWidget.takeAction(actions, params);
                            self._switchSelection(self.indexLink.parentNode);
                            return self.indexWidget;
                        }
                    },
                    connectorsAction = {
                        currentAction: "connectors",
                        takeAction: function(actions, params) {
                            self.widgetContainer.selectChild(self.connectorsWidget);
                            self.connectorsWidget.takeAction(actions, params);
                            self._switchSelection(self.connectorsLink.parentNode);
                            return self.connectorsWidget;
                        }
                    };

                this.currentAction = boostingAction.currentAction;
                this.registerAction(boostingAction.currentAction, boostingAction);
                this.registerAction(indexAction.currentAction, indexAction);
                this.registerAction(connectorsAction.currentAction, connectorsAction);

                this.own(
                    on(this.boostingLink, "click", function(event) {
                        topic.publish(config.intents.view.boosting);
                        event.preventDefault();
                    }),
                    on(this.indexLink, "click", function(event) {
                        topic.publish(config.intents.view.index);
                        event.preventDefault();
                    }),
                    on(this.connectorsLink, "click", function(event) {
                        topic.publish(config.intents.view.connectors);
                        event.preventDefault();

                    })
                );

                this.previousActionFallback = true;
            },

            startup: function() {
                this.inherited(arguments);
                this.takeAction([this.currentAction]);
            },

            _switchSelection: function(/*domNode*/ node) {
                // summary:
                //      Removes current selection indication and puts selection indicator to a new node
                query(".epi-pane__content__nav li.is-active", this.domNode).removeClass("is-active");
                domClass.add(node, "is-active");
            }
        });
    });
