require({cache:{
'url:epi-find/widget/templates/Connectors.html':"﻿<div>\r\n    <p class=\"epi-view--description\">${i18n.description}</p>\r\n    <form data-dojo-attach-point=\"connectorsFormNode\"></form>\r\n    <p class=\"epi-help\">${i18n.help_grid}</p>\r\n    <div id=\"connectorsgrid\" data-dojo-attach-point=\"connectorsGridNode\"></div>\r\n</div>"}});
﻿define("epi-find/widget/Connectors", [
        "dojo/_base/declare",

        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "dijit/_FocusMixin",
        "dijit/layout/_LayoutWidget",

        "epi-saas-base/Sticker",

        "./_ActionableMixin",
        "./_SiblingFocusMixin",
        "./_DisabledViewMixin",
        "./ConnectorForm",
        "./ConnectorGrid",

        "dojo/i18n!./nls/Connectors",
        "dojo/text!./templates/Connectors.html"
],
    function(declare,
             _WidgetBase,
             _TemplatedMixin,
             _FocusMixin,
             _LayoutWidget,

             Sticker,

             _ActionableMixin,
             _SiblingFocusMixin,
             _DisabledViewMixin,
             ConnectorForm,
             ConnectorGrid,

             i18n,
             template) {

        // module:
        //      epi-find/widget/Connectors

        return declare([_WidgetBase, _LayoutWidget, _TemplatedMixin, _ActionableMixin, _FocusMixin, _SiblingFocusMixin, _DisabledViewMixin], {
            // summary:
            //     Manage view.

            templateString: template,

            i18n: i18n,

            // model: epi-find/configure/ConnectorModel
            //      Model for the connectors view
            model: null,

            connectorForm: null,
            connectorGrid: null,

            postCreate: function() {
                this.inherited(arguments);

                var connectorForm = this.connectorForm = new ConnectorForm({
                    model: this.model,
                    onSubmitted: function() {
                        // HACK: Workaround for delayed update
                        setTimeout(function() {
                            grid.refresh();
                        }, 5000);
                    }
                }, this.connectorsFormNode);
                connectorForm.reset();
                this.own(connectorForm);

                var grid = this.connectorGrid = new ConnectorGrid({
                    "class": "epi-plain-grid epi-plain-grid--no-border",
                    margin: 140,
                    model: this.model,
                    loadingMessage: i18n.dataLoading,
                    showLoadingMessage: true,
                    onEdit: function(id) {
                        connectorForm.edit(id);
                    }
                }, this.connectorsGridNode);
                this.own(grid);
            },

            startup: function() {
                var scrollNode = this.scrollNode || this.domNode.parentNode;
                this.connectorGrid.set("scrollNode", scrollNode);
                this.inherited(arguments);
                this.connectorForm.startup();
                this.connectorGrid.startup();
                this.own(
                    new Sticker({
                        domNode: this.connectorGrid.headerNode,
                        offset: {top: 0},
                        scrollNode: scrollNode,
                        limitNode: this.connectorGrid.domNode
                    })
                );
            },

            layout: function() {
                // We resize the grid in order to make sure that sizes of header, scroller, etc
                // are recalculated when it's needed, for instance, when grid becomes visible.
                this.connectorGrid.resize();
            },

            takeAction: function() {
                this.connectorGrid.refresh();
                return this;
            }
        });
    });
