require({cache:{
'url:epi-find/widget/templates/Contents.html':"<div class=\"epi-pane epi-pane--tools is-active epi-focused\">\r\n    <div class=\"epi-pane__content-wrapper\">\r\n        <div class=\"epi-pane__header\">\r\n            <h1>${i18n.header}</h1>\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n        </div>\r\n        <div data-dojo-attach-point=\"contentNode\" class=\"epi-pane__content\">\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n                <ul class=\"epi-pane__content__nav clearfix\">\r\n                    <li><a href=\"#\" title=\"${i18n.nav_overview}\" class=\"epi-pane__content__header-link--overview\" data-dojo-attach-point=\"overviewLink\">${i18n.nav_overview}</a></li>\r\n                    <li><a href=\"#\" title=\"${i18n.nav_explore}\" class=\"epi-pane__content__header-link--explore\" data-dojo-attach-point=\"exploreLink\">${i18n.nav_explore}</a></li>\r\n                </ul>\r\n                <div data-dojo-type=\"dijit/layout/StackContainer\" data-dojo-attach-point=\"widgetContainer\" data-dojo-props=\"doLayout: false, isLayoutContainer: true\" class=\"epi-pane__content__content-container\"></div>\r\n        </div>\r\n    </div>\r\n</div>"}});
define("epi-find/widget/Contents", [
    "dojo/_base/config",
    "dojo/_base/declare",
    "dojo/on",
    "dojo/topic",
    "dojo/dom-class",
    "dojo/query",

    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_TemplatedMixin",

    "./_ActionableMixin",
    "./Overview",
    "./Explore",

    "../AccessModel",

    "dojo/i18n!./nls/Contents",
    "dojo/text!./templates/Contents.html"
],
function(config,
    declare,
    on,
    topic,
    domClass,
    query,
    _WidgetBase,
    _WidgetsInTemplateMixin,
    _TemplatedMixin,
    _ActionableMixin,
    Overview,
    Explore,
    AccessModel,
    i18n,
    template) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionableMixin], {
        // summary:
        //     Overview view.

        templateString: template,

        i18n: i18n,

        overviewModel: null,
        exploreModel: null,

        constructor: function() {
            this.inherited(arguments);
        },

        postCreate: function() {
            this.inherited(arguments);

            this.overviewWidget = new Overview({
                model: this.overviewModel,
                disabledView: !AccessModel.isEnabled(config.intents.view.overview),
                scrollNode: this.contentNode
            });
            this.widgetContainer.addChild(this.overviewWidget);
            this.own(this.overviewWidget);

            this.exploreWidget = new Explore({
                model: this.exploreModel,
                disabledView: !AccessModel.isEnabled(config.intents.view.explore),
                scrollNode: this.contentNode
            });
            this.widgetContainer.addChild(this.exploreWidget);
            this.own(this.exploreWidget);

            var self = this,
                overviewAction = {
                    currentAction: "overview",
                    takeAction: function(actions, params) {
                        self.widgetContainer.selectChild(self.overviewWidget);
                        self.overviewWidget.takeAction(actions, params);
                        self._switchSelection(self.overviewLink.parentNode);
                        return self.overviewWidget;
                    }
                },
                exploreAction = {
                    currentAction: "explore",
                    takeAction: function(actions, params) {
                        self.widgetContainer.selectChild(self.exploreWidget);
                        self.exploreWidget.takeAction(actions, params);
                        self._switchSelection(self.exploreLink.parentNode);
                        return self.exploreWidget;
                    }
                };

            this.currentAction = overviewAction.currentAction;
            this.registerAction(overviewAction.currentAction, overviewAction);
            this.registerAction(exploreAction.currentAction, exploreAction);

            this.own(
                on(this.overviewLink, "click", function(event) {
                    topic.publish(config.intents.view.overview);
                    event.preventDefault();
                }),
                on(this.exploreLink, "click", function(event) {
                    topic.publish(config.intents.view.explore);
                    event.preventDefault();

                })
            );

            this.previousActionFallback = true;
        },

        startup: function() {
            this.inherited(arguments);
            this.takeAction([this.currentAction]);
        },

        _switchSelection: function(/*domNode*/ node) {
            // summary:
            //      Removes current selection indication and puts selection indicator to a new node
            query(".epi-pane__content__nav li.is-active", this.domNode).removeClass("is-active");
            domClass.add(node, "is-active");
        }
    });
});
