define("epi-find/widget/CustomRanges", [
        "dojo/date",
        "dijit/layout/ContentPane",
        "dijit/form/DateTextBox",
        "dojo/i18n!./nls/Dashboard",
    ],
    function(
        date,
        ContentPane,
        DateTextBox,
        i18n
    ) {
    var today = new Date();

    var Ranges = {
        endDate: new DateTextBox({
            value: today,
            name: "endDate",
            disabled: true
        }),
        startDate: new DateTextBox({
            value: new Date(today.setDate(today.getDate()-1)),
            name: "startDate",
            disabled: true
        }),
        interval: "day",
        dateRange: new ContentPane({
            "class": "epi-pane__content__date-range-wrapper"
        }),

        disabledStatus: true,
        setDisabled: function(value) {
            Ranges.disabledStatus = value;
            Ranges.startDate.set("disabled", Ranges.disabledStatus);
            Ranges.endDate.set("disabled", Ranges.disabledStatus);
        }
    };

    var startDateDiv = dojo.create("div", { "class": "height-35" });
    dojo.place("<div class='float-left padding-top-5 padding-left-15'><label for='startDate'>" + i18n.startDate + "</label></div>", startDateDiv);
    var startDatePicker = dojo.create("div", { "class": "float-right" });
    dojo.place(Ranges.startDate.domNode, startDatePicker);
    dojo.place(startDatePicker, startDateDiv);

    var endDateDiv = dojo.create("div", { "class": "height-35" });
    dojo.place("<div class='float-left padding-top-5 padding-left-15'><label for='endDate'>" + i18n.endDate + "</label></div>", endDateDiv);
    var endDatePicker = dojo.create("div", { "class": "float-right" });
    dojo.place(Ranges.endDate.domNode, endDatePicker);
    dojo.place(endDatePicker, endDateDiv);

    Ranges.dateRange.domNode.appendChild(startDateDiv);
    Ranges.dateRange.domNode.appendChild(endDateDiv);

    return Ranges;
});
