define("epi-find/widget/DashboardGrid", [
        "dojo/_base/declare",
        "dojo/dom-construct",
        "dojo/dom-class",
        "dojo/dom-style",
        "dojo/on",
        "dojo/query",
        "dijit/Destroyable",
        "dgrid/Selection",
        "dgrid/selector",
        "dgrid/OnDemandGrid",
        "dgrid/extensions/ColumnHider",
        "dgrid/extensions/Pagination",
        "dojox/html/entities",
        "epi-saas-base/widgets/_GridNumberedColumnMixin",
        "dojo/i18n!./nls/Dashboard"
    ],
    function(
            // dojo
            declare,
            domConstruct,
            domClass,
            domStyle,
            on,
            query,
            // dijit
            Destroyable,
            // dgrid
            Selection,
            selector,
            OnDemandGrid,
            ColumnHider,
            Pagination,
            // dojox
            entities,
            _GridNumberedColumnMixin,
            // .
            i18n) {

        return    declare([Destroyable, OnDemandGrid, Selection, ColumnHider, Pagination, _GridNumberedColumnMixin], {

            numberedColumnId: "phrase",
            columns: {
                selector: selector({
                    className: "epi-grid-column--snug",
                    label: "",
                    selectorType: "checkbox",
                    sortable: false
                }),

                phrase: {
                    field: "query",
                    label: i18n.fields_query,
                    renderCell: function (object, value, node) {
                        var grid = this.grid,
                            anchor = domConstruct.create("a", {
                                innerHTML: entities.encode(value),
                                "class": "epi-visibleLink"
                            }, node);
                        grid.own(
                            on(anchor, "mousedown, click", function (e) {
                                e.preventDefault();
                                e.stopPropagation();
                                e.phrase = object;
                                on.emit(grid.contentNode, "phrase-click", e);
                            })
                        );
                    },
                    sortable: false
                },
                number: {
                    field: "count",
                    className: "epi-grid-column--centered",
                    label: i18n.fields_numberOfSearches,
                    renderCell: function (object, value, node) {
                        domClass.add(node, "epi-grid-column--positive");
                        node.innerHTML = value;
                    },
                    sortable: false
                },
                total: {
                    className: "epi-grid-column--centered",
                    label: i18n.fields_numberOfSearches,
                    get: function (object) {
                        if (object.extended) {
                            return object.extended.total;
                        }
                    },
                    renderCell: function (object, value, node) {
                        domClass.add(node, "epi-grid-column--positive");
                        node.innerHTML = value;
                    },
                    sortable: false,
                    hidden: true
                },
                percentage: {
                    className: "epi-grid-column--centered",
                    label: i18n.fields_clickRate,
                    get: function (object) {
                        if (object.extended) {
                            return 100 - Math.round(object.count / object.extended.total * 100) + "%"; // Returning how many percent of all searches that resulted in any clicks
                        }
                    },
                    renderCell: function (object, value, node) {
                        domClass.add(node, "epi-grid-column--negative");
                        node.innerHTML = value;
                    },
                    sortable: false,
                    hidden: true
                }
            },
            firstLastArrows: true,
            pageSizeOptions: [10, 15, 25, 50],

            selectionMode: "toggle",
            allowTextSelection: false,
            noDataMessage: i18n.noResults,

            startup: function () {
                this.inherited(arguments);
                domStyle.set(this.hiderToggleNode, "display", "none"); // We only want to show/hide columns programmatically
            }

        });
});