require({cache:{
'url:epi-find/widget/templates/Explore.html':"﻿<div>\r\n    <p class=\"epi-view--description\">${i18n.description}</p>\r\n    <div data-dojo-type=\"epi-find/widget/ContentWrapperWithSidebar\" data-dojo-attach-point=\"contentWrapper\" class=\"epi-explore__content_container\">\r\n        <div class=\"epi-clear-both epi-no-overflow-x\" data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"mainPane\">\r\n            <p class=\"epi-help\">${i18n.help_search}</p>\r\n            <div data-dojo-attach-point=\"containerNode\">\r\n                <div data-dojo-attach-point=\"mainContentNode\">\r\n                    <div class=\"epi-box epi-background--dark-grey epi-search-box\">\r\n                        <input id=\"queryNode\" type=\"text\" name=\"query\"\r\n                            class=\"epi-search-input\"\r\n                            data-dojo-type=\"dijit/form/TextBox\"\r\n                            data-dojo-props=\"trim: true, intermediateChanges: true\"\r\n                            data-dojo-attach-point=\"queryNode\" placeholder=\"${i18n.search}\" />\r\n                    </div>\r\n                </div>\r\n                <div class=\"epi-clear-both\" data-dojo-attach-point=\"totalNode\"></div>\r\n                <p class=\"epi-clear-both epi-help\">${i18n.help_documents}</p>\r\n            </div>\r\n            <div class=\"epi-plain-grid  epi-plain-grid--no-border  epi-grid-max-height--700\" data-dojo-attach-point=\"resultsGridNode\"></div>\r\n        </div>\r\n        <div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"filterPane\">\r\n            <p class=\"epi-help\">${i18n.help_documentTypes}</p>\r\n            <div data-dojo-attach-point=\"filterSticker\">\r\n                <h2 class=\"epi-explore__filter-header\">${i18n.filter}</h2>\r\n                <div class=\"epi-chromeless  epi-chromeless--with-pointer  epi-chromeless--no-header  epi-explore__filter-grid\" data-dojo-attach-point=\"typeFacetGridNode\"></div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n"}});
define("epi-find/widget/Explore", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/json",
    "dojo/on",
    "dojo/query",
    "dojo/dom-class",
    "dojo/when",

    "dojox/html/entities",
    "dojox/mvc/at",
    "dojox/mvc/Output",

    "dijit/layout/ContentPane",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/form/TextBox",

    "dgrid/Grid",
    "dgrid/Selection",
    "dgrid/OnDemandGrid",

    "put-selector/put",

    "epi-saas-base/Sticker",
    "epi-saas-base/StickyContainer",
    "epi-saas-base/widgets/_GridMoreMixin",
    "epi-saas-base/widgets/_AutoLoadScrollMixin",

    "./_ActionableMixin",
    "./_DisabledViewMixin",
    "./ContentWrapperWithSidebar",
    "./HelpText",

    "dojo/i18n!./nls/Explore",
    "dojo/text!./templates/Explore.html"
],
function (declare,
    lang,
    JSON,
    on,
    query,
    domClass,
    when,
    entities,
    at,
    Output,
    ContentPane,
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    TextBox,
    Grid,
    Selection,
    OnDemandGrid,
    put,
    Sticker,
    StickyContainer,
    _GridMoreMixin,
    _AutoLoadScrollMixin,
    _ActionableMixin,
    _DisabledViewMixin,
    ContentWrapperWithSidebar,
    HelpText,
    i18n,
    template) {

    // module:
    //      epi-find/widget/Explore

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionableMixin, _DisabledViewMixin], {
        // summary:
        //     Explore view.

        templateString: template,

        i18n: i18n,

        model: null,

        resultsGrid: null,
        typeFacetGrid: null,

        expandedNode: null,

        _searchText: null,
        _typeFilter: null,

        _modelUpdateTimeout: 400,
        _modelUpdateTimer: null,

        postCreate: function () {
            this.inherited(arguments);

            if (!this.model) {
                throw new Error("'model' is not defined");
            }

            var model = this.model,
                AutoLoadScrollGrid = declare([Grid, _GridMoreMixin, _AutoLoadScrollMixin], {
                    constructor: function() {
                        this.loader = lang.hitch(this, this.loadNextPage);
                    }
                });

            this._typeFilter = this.model.typeFilter;
            this._searchText = this.model.searchText;

            this.contentWrapper.addSidebar(this.filterPane);

            // Main document explore list
            this.resultsGrid = new AutoLoadScrollGrid({
                className: "epi-plain-grid epi-stack-list-wrapper",
                showFooter: false,
                useTouchScroll: false,
                store: this.model.store,
                query: this.model.query,
                pagingDelay: 200,
                margin: 140,
                columns: [
                    {
                        className: "epi-grid-column--icon24x24",
                        renderCell: function () {
                            return put("div.epi-gridIconCollapsed");
                        }
                    },
                    {
                        label: i18n.fields_name,
                        sortable: true,
                        className: "epi-grid-column--sortable--tight-arrow",
                        field: "name",
                        renderHeaderCell: function() {
                            return put("span.epi-grid-column-header__string-wrapper", i18n.fields_name);
                        },
                        get: function (object) {
                            return object.fields.partial_source.SearchTitle$$string ||
                                object.fields.partial_source.PageName$$string ||
                                object.fields.partial_source.Name$$string ||
                                object.fields.partial_source.title || // for RSS/ATOM feeds
                                object._id;
                        },
                        renderCell: function (object, value, node) {
                            node.title = object._id;
                            node.innerHTML = entities.encode(value || "");
                        }
                    },
                    {
                        label: i18n.fields_type,
                        sortable: true,
                        field: "type",
                        className: "epi-grid-column--right epi-grid--30 epi-color-secondary epi-columnPadding--right",
                        get: function (object) {
                            return model.getShortTypeName(object.fields.partial_source.$type);
                        },
                        renderCell: function (object, value, node) {
                            node.title = object.fields.partial_source.$type;
                            node.innerHTML = value;
                        }
                    }
                ],
                noDataMessage: i18n.noResults,
                loadingMessage: i18n.dataLoading,
                showLoadingMessage: true,
                renderRow: function (object) {
                    var div = put("div.collapsed", Grid.prototype.renderRow.apply(this, arguments)),
                        pre = put("pre", JSON.stringify(object.fields.partial_source, null, 4));
                        put(div, "div.expando", pre);
                    return div;
                }
            }, this.resultsGridNode);

            var SelectGrid = declare([OnDemandGrid, Selection], {});
            this.typeFacetGrid = new SelectGrid({
                columns: [
                    {
                        get: function (object) {
                            return object.term;
                        },
                        renderCell: function (object, value, node) {
                            node.title = value;
                            node.innerHTML = model.getShortTypeName(value);
                        }
                    },
                    {
                        className: "epi-grid-column--right  epi-grid-column--bold  epi-grid--30",
                        get: function (object) {
                            return object.count;
                        },
                        renderCell: function (object, value, node) {
                            node.title = value;
                            node.innerHTML = value;
                        }
                    }
                ],
                useTouchScroll: false,
                showHeader: false,
                noDataMessage: i18n.noResults,  // Data is provided via #renderArray, so message will never be shown.
                selectionMode: "toggle",
                deselectOnRefresh: false,
                store: this.model.typeFacetStore
            }, this.typeFacetGridNode);

            // Displaying total number of found documents
            var totalDocumentsWidget = new Output({
                value: at(this.model, "totalDocuments")
                    .direction(at.from)
                    .transform({
                        format: function(total){
                            return "<p class=\"epi-floatRight\">" + i18n.results.replace("{0}", total ? total : 0) + "</p>";
                        }
                    })
            }, this.totalNode);
            this.own(totalDocumentsWidget);

            this.own(
                // Update query parameters when type filter is selected
                on(this.typeFacetGrid, "dgrid-select", lang.hitch(this, function () {
                    this._updateTypeFilter();
                    this._delayedReload();
                })),
                on(this.typeFacetGrid, "dgrid-deselect", lang.hitch(this, function () {
                    this._updateTypeFilter();
                    this._delayedReload();
                })),

                // Update query with new search text value
                on(this.queryNode, "change", lang.hitch(this, function () {
                    var searchText = lang.trim(this.queryNode.get("value").toLowerCase() || "");
                    this.resultsGrid.updateSortArrow([], true);
                    this._searchText = searchText;
                    this._delayedReload();
                })),

                // Expand/collapse document data rows (on cell only, not for expanded)
                on.pausable(this.resultsGrid, ".dgrid-row .dgrid-cell:click", lang.hitch(this, function (event) {
                    var node = this.resultsGrid.row(event).element,
                        collapsed = node.className.indexOf("collapsed") >= 0;

                    // toggle state of node which was clicked
                    put(node, (collapsed ? "!" : ".") + "collapsed");
                    this._toggleResultRowIcon(node);

                    // if clicked row was not expanded, collapse any previously-expanded row
                    if(collapsed && this.expandedNode) {
                        put(this.expandedNode, ".collapsed");
                        this._toggleResultRowIcon(this.expandedNode);
                    }
                    // if the row clicked was previously expanded, nothing is expanded now
                    this.expandedNode = collapsed ? node : null;
                })),
                on(this.resultsGrid, "dgrid-error", lang.hitch(this, function () {
                    // removing existing noData node and creating new one with error message
                    if(this.resultsGrid.noDataNode){
                        put(this.resultsGrid.noDataNode, "!");
                        delete this.resultsGrid.noDataNode;
                    }
                    this.resultsGrid.noDataNode = put(this.resultsGrid.contentNode, "div.dgrid-no-data");
                    this.resultsGrid.noDataNode.innerHTML = i18n.dataLoadError;
                })),
                on(this.resultsGrid, "dgrid-sort", lang.hitch(this, function(event) {
                    event.preventDefault();
                    this._sort = event.sort;
                    this._delayedReload();
                }))
            );

            this.own(
                this.model.watch("queryInProgress", lang.hitch(this, function (name, oldValue, queryInProgress) {
                    if (!queryInProgress) {
                        this.typeFacetGrid.refresh();
                    }
                }))
            );

            this.queryNode.set("value", this.model.searchText);
        },

        takeAction: function() {
            this.refresh();
            return this;
        },

        refresh: function() {
            this.model.set("searchText", this._searchText || null);
            this.model.set("typeFilter", this._typeFilter || null);
            this.model.set("sort", this._sort || []);
            this.model.resetPaging();
            this.resultsGrid.set("query", this.model.query);
            this.resultsGrid.updateSortArrow(this.model.sort, true);
        },

        _updateTypeFilter: function() {
            this._typeFilter = [];
            for(var id in this.typeFacetGrid.selection){
                if(this.typeFacetGrid.selection[id]){
                    this._typeFilter.push(id);
                }
            }
        },

        _delayedReload: function() {
            //  summary:
            //      Updates model parameters and reloads data after delay in order to avoid extra requests.
            if (this._modelUpdateTimer) {
                clearTimeout(this._modelUpdateTimer);
            }
            this._modelUpdateTimer = setTimeout(lang.hitch(this, function () {
                if (this.model.get("queryInProgress")) {
                    this._delayedReload();
                    return;
                }

                clearTimeout(this._modelUpdateTimer);
                this._modelUpdateTimer = null;
                this.refresh();
            }), this._modelUpdateTimeout);
        },

        _toggleResultRowIcon: function (rowNode) {
            query(".epi-grid-column--icon24x24 div", rowNode).forEach(function(iconNode){
                domClass.toggle(iconNode, "epi-gridIconCollapsed");
                domClass.toggle(iconNode, "epi-gridIconExpanded");
            });
        },

        resize: function() {
            this.inherited(arguments);
            this.resultsGrid.resize();
        },

        startup: function() {
            this.inherited(arguments);
            var grid = this.resultsGrid;
            this.resultsGrid.startup();
            grid.set("scrollNode", this.domNode.parentNode);
            grid.on("dgrid-refresh-complete", function() {
                grid.load();
            });

            this.own(
                new StickyContainer({
                    scrollNode: this.domNode.parentNode,
                    stickers: [
                        new Sticker({ domNode: this.containerNode, offset: {top: 0}, limitNode: this.resultsGridNode, subscribe: false}),
                        new Sticker({ domNode: this.resultsGrid.headerNode, offset: {top: 0}, limitNode: this.resultsGridNode, subscribe: false})
                    ]
                }),
                new Sticker({ domNode: this.filterSticker, offset: {top: 0}, scrollNode: this.domNode.parentNode})
            );
        }

    });
});
