require({cache:{
'url:epi-find/widget/templates/Index.html':"﻿<form data-dojo-attach-point='containerNode'>\r\n    <p class=\"epi-clear-index--description\">${i18n.description}</p>\r\n    <div class=\"epi-clear-index-wrapper\">\r\n      <div class=\"epi-clear-index-column\">\r\n        <h1>${i18n.labels_clearIndex}</h1>\r\n        <p>${clearIndexDescription}</p>\r\n        <span class=\"epi-sprite epi-sprite--clear-content\"></span>\r\n\r\n        <input data-dojo-attach-point=\"clearIndexButton\"\r\n                     type=\"button\"\r\n                     data-dojo-type=\"dijit/form/Button\"\r\n                     data-dojo-props=\"class: 'epi-danger'\" />\r\n      </div>\r\n\r\n      <div class=\"epi-clear-index-column\">\r\n        <h1>${i18n.labels_clearStats}</h1>\r\n        <p>${i18n.clearStatsDescription}</p>\r\n        <span class=\"epi-sprite epi-sprite--clear-stats\"></span>\r\n\r\n        <input data-dojo-attach-point=\"clearStatsButton\"\r\n                   type=\"button\"\r\n                   data-dojo-type=\"dijit/form/Button\"\r\n                   data-dojo-props=\"class: 'epi-danger'\" />\r\n      </div>\r\n    </div>\r\n</form>\r\n"}});
﻿define("epi-find/widget/Index", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/when",
    "dojo/dom-class",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/form/Button",

    "epi-saas-base/widgets/_NotificationMixin",
    "epi-saas-base/widgets/_ActionButtonsMixin",

    "./_ActionableMixin",
    "./_DisabledViewMixin",

    "dojo/i18n!./nls/Index",
    "dojo/text!./templates/Index.html"
],
    function(declare,
             lang,
             on,
             when,
             domClass,
            _WidgetBase,
            _TemplatedMixin,
            _WidgetsInTemplateMixin,
            _LayoutWidget,
            Button,
            _NotificationMixin,
            _ActionButtonsMixin,
            _ActionableMixin,
			_DisabledViewMixin,
            i18n,
            template) {
        return declare([_WidgetBase, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionableMixin, _DisabledViewMixin, _NotificationMixin, _ActionButtonsMixin], {
            // summary:
            //     Clear content index and stats view.

            templateString: template,

            i18n: i18n,

            model: null,

            // reindexNote: String
            //      The note about possibly required reindexing after clearing operation.
            reindexNote: null,

            postMixInProperties: function(){
                this.inherited(arguments);
                this.reindexNote = this.model.indexingPluginUrl ?
                    lang.replace(i18n.reindexNote,
                        [ lang.replace("<a href='{0}' class='epi-visibleLink'>{1}</a>",
                            [this.model.indexingPluginUrl, i18n.indexingJobPageTitle])
                        ]) : "";
                this.clearIndexDescription = this.model.indexingPluginUrl ?
                    lang.replace(i18n.clearIndexDescription, [this.model.indexingPluginUrl]) : "";
            },

            postCreate: function() {
                this.inherited(arguments);

                this.clearIndexButton.set("label", i18n.buttons_clearIndex);
                this.clearStatsButton.set("label", i18n.buttons_clearStats);

                if (!this.model) {
                    throw "No model specified";
                }

                this.actionButtons = [
                    this.clearIndexButton,
                    this.clearStatsButton
                ];

                this.disableWhenNoChanges = false;

                this.own(
                    on(this.clearIndexButton, "click", lang.hitch(this, function (e) {
                        e.preventDefault();
                        e.stopPropagation();

                        this.showConfirmation({
                            title: i18n.notification_clearIndexTitle,
                            message: i18n.notification_clearIndexDescription,
                            action: lang.hitch(this, this.clearIndex),
                            confirmActionText: i18n.buttons_confirmClearContent,
                            cancelActionText: i18n.buttons_confirmCancel
                        });
                    })),

                    on(this.clearStatsButton, "click", lang.hitch(this, function (e) {
                        e.preventDefault();
                        e.stopPropagation();

                        this.showConfirmation({
                            title: i18n.notification_clearStatsTitle,
                            message: i18n.notification_clearStatsDescription,
                            action: lang.hitch(this, this.clearStats),
                            confirmActionText: i18n.buttons_confirmClearStatistics,
                            cancelActionText: i18n.buttons_confirmCancel
                        });
                    })));
            },


            clearIndex: function(){
                // summary:
                //          Clears the content index and shows results
                this.indicateInProgress(this.clearIndexButton, i18n.buttons_clearingIndex);

                return when(this.model.clearContentIndex(), lang.hitch(this, function(success) {
                    this.indicateSuccess(this.clearIndexButton, i18n.buttons_clearIndex);
                    this.showSuccess(i18n.notification_successClearIndex + "<br/>" + this.reindexNote,
                        i18n.notification_clearIndexTitle);
                }), lang.hitch(this,function(error){
                    this.indicateError(this.clearIndexButton, i18n.buttons_clearIndex);
                    var errorText = (error || {}).responseText ? error.responseText : i18n.notification_errorClearIndex;
                    this.showError(error, errorText +
                        (error ? " " + i18n.notification_errorDetails : ""),
                        i18n.notification_clearIndexTitle);
                }));
            },

            clearStats: function(){
                // summary:
                //          Clears the statistics and shows results

                this.indicateInProgress(this.clearStatsButton, i18n.buttons_clearingStats);

                return when(this.model.clearStats(), lang.hitch(this, function(success){
                    this.indicateSuccess(this.clearStatsButton, i18n.buttons_clearStats);
                    this.showSuccess(i18n.notification_successClearStats, i18n.notification_clearStatsTitle);
                }), lang.hitch(this, function(error){
                    this.indicateError(this.clearStatsButton, i18n.buttons_clearStats);
                    var errorText = (error || {}).responseText ? error.responseText : i18n.notification_errorClearStats;
                    this.showError(error, errorText +
                        (error ? " " + i18n.notification_errorDetails : ""),
                        i18n.notification_clearStatsTitle);
                }));
            }
        });
    });
