require({cache:{
'url:epi-find/widget/templates/Optimization.html':"<div class=\"epi-pane  epi-pane--tools is-active epi-focused\">\r\n    <div class=\"epi-pane__content-wrapper\">\r\n        <div class=\"epi-pane__header\">\r\n            <h1>${i18n.header}</h1>\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n        </div>\r\n        <div data-dojo-attach-point=\"contentNode\" class=\"epi-pane__content\">\r\n            <p class=\"epi-pane__description\">${i18n.description}</p>\r\n            <ul class=\"epi-pane__content__nav clearfix\" data-dojo-attach-point=\"links\">\r\n                <li><a href=\"#\" title=\"${i18n.nav_bestBets}\" class=\"epi-pane__content__header-link--best-bets\" data-dojo-attach-point=\"bestBetsLink\">${i18n.nav_bestBets}</a></li>\r\n                <li><a href=\"#\" title=\"${i18n.nav_relatedQueries}\" class=\"epi-pane__content__header-link--related-queries\" data-dojo-attach-point=\"relatedQueriesLink\">${i18n.nav_relatedQueries}</a></li>\r\n                <li><a href=\"#\" title=\"${i18n.nav_synonyms}\" class=\"epi-pane__content__header-link--synonyms\" data-dojo-attach-point=\"synonymsLink\">${i18n.nav_synonyms}</a></li>\r\n                <li><a href=\"#\" title=\"${i18n.nav_autocomplete}\" class=\"epi-pane__content__header-link--autocomplete\" data-dojo-attach-point=\"autocompleteLink\">${i18n.nav_autocomplete}</a></li>\r\n            </ul>\r\n            <div data-dojo-attach-point=\"containerNode\" class=\"epi-pane__content__content-container\"></div>\r\n        </div>\r\n    </div>\r\n</div>"}});
﻿define("epi-find/widget/Optimization", [
    "dojo/_base/declare",
    "dojo/_base/config",
    "dojo/on",
    "dojo/topic",
    "dojo/query",

    "dojo/dom-class",

    "dijit/_TemplatedMixin",
    "dijit/layout/ContentPane",

    "./_ActionableMixin",
    "./Synonyms",
    "./Bestbets",
    "./RelatedQueries",
    "./Autocomplete",

    "../AccessModel",

    "dojo/i18n!./nls/Optimization",
    "dojo/text!./templates/Optimization.html"
],
function (declare,
        config,
        on,
        topic,
        query,
        domClass,
        _TemplatedMixin,
        ContentPane,
        _ActionableMixin,
        Synonyms,
        BestBets,
        RelatedQueries,
        Autocomplete,
        AccessModel,
        i18n,
        template) {

    // module:
    //      epi-find/widget/Optimization

    return declare([ContentPane, _TemplatedMixin, _ActionableMixin], {
        // summary:
        //     Optimization view.

        i18n: i18n,
        templateString: template,

        _synonyms: null,
        _bestBets: null,
        _relatedQueries: null,

        postCreate: function() {
            this.inherited(arguments);

            this._bestBets = new BestBets({
                scrollNode: this.scrollNode
            });
            this.own(this._bestBets);

            this._relatedQueries = new RelatedQueries({
                model: this.model.relatedQueriesModel,
                scrollNode: this.scrollNode
            });
            this.own(this._relatedQueries);

            this._synonyms = new Synonyms({
                disabledView: !AccessModel.isEnabled(config.intents.view.synonyms),
                scrollNode: this.scrollNode
            });
            this.own(this._synonyms);

            this._autocomplete = new Autocomplete({
                model: this.model.autocompleteModel,
                scrollNode: this.scrollNode
            });
            this.own(this._autocomplete);

            var self = this,
                bestBetsAction = {
                    currentAction: "bestbets",
                    takeAction: function(actions, params) {
                        self.removeChildren();
                        self.addChild(self._bestBets);
                        self._bestBets.takeAction(actions, params);
                        self._switchSelection(self.bestBetsLink.parentNode);
                        return self._bestBets;
                    }
                },
                relatedQueriesAction = {
                    currentAction: "relatedqueries",
                    takeAction: function(actions, params) {
                        self.removeChildren();
                        self.addChild(self._relatedQueries);
                        self._relatedQueries.takeAction(actions, params);
                        self._switchSelection(self.relatedQueriesLink.parentNode);
                        return self._relatedQueries;
                    }
                },
                synonymsAction = {
                    currentAction: "synonyms",
                    takeAction: function(actions, params) {
                        self.removeChildren();
                        self.addChild(self._synonyms);
                        self._synonyms.takeAction(actions, params);
                        self._switchSelection(self.synonymsLink.parentNode);
                        return self._synonyms;
                    }
                },
                autocompleteAction = {
                    currentAction: "autocomplete",
                    takeAction: function(actions, params) {
                        self.removeChildren();
                        self.addChild(self._autocomplete);
                        self._autocomplete.takeAction(actions, params);
                        self._switchSelection(self.autocompleteLink.parentNode);
                        return self._autocomplete;
                    }
                };
            this.currentAction = bestBetsAction.currentAction;
            this.registerAction(bestBetsAction.currentAction, bestBetsAction);
            this.registerAction(relatedQueriesAction.currentAction, relatedQueriesAction);
            this.registerAction(synonymsAction.currentAction, synonymsAction);
            this.registerAction(autocompleteAction.currentAction, autocompleteAction);

            this.own(
                on(this.bestBetsLink, "click", function(event) {
                    topic.publish(config.intents.view.bestBets);
                    event.preventDefault();
                }),
                on(this.relatedQueriesLink, "click", function(event) {
                    topic.publish(config.intents.view.relatedQueries);
                    event.preventDefault();
                }),
                on(this.synonymsLink, "click", function(event) {
                    topic.publish(config.intents.view.synonyms);
                    event.preventDefault();
                }),
                on(this.autocompleteLink, "click", function(event) {
                    topic.publish(config.intents.view.autocomplete);
                    event.preventDefault();
                })
            );

            this.previousActionFallback = true;
        },

        startup: function() {
            this.inherited(arguments);
            this.takeAction([this.currentAction]);
        },

        removeChildren: function () {
             while(this.getChildren().length > 0) {
                this.removeChild(0);
             }
        },

        refresh: function() {
            this._synonyms.refresh();
            this._bestBets.refresh();
            this._relatedQueries.refresh();
            this._autocomplete.refresh();
        },

        hideChildren: function() {
            this.inherited(arguments);
            domClass.add(this.links, "epi-hidden");
        },

        showChildren: function() {
            this.inherited(arguments);
            domClass.remove(this.links, "epi-hidden");
        },

        _switchSelection: function(/*domNode*/ node) {
            // summary:
            //      Removes current selection indication and puts selection indicator to a new node
            query(".epi-pane__content__nav li.is-active", this.domNode).removeClass("is-active");
            domClass.add(node, "is-active");
        }

    });
});