require({cache:{
'url:epi-find/widget/templates/PhraseDashboardDialog.html':"<div>\r\n    <div class=\"epi-column clearfix\" data-dojo-attach-point=\"mostClickedContainerNode\">\r\n        <p data-dojo-attach-point=\"mostClickedTitleNode\"></p>\r\n        <div data-dojo-attach-point=\"mostClickedGridNode\"></div>\r\n    </div>\r\n    <div class=\"epi-column clearfix\" data-dojo-attach-point=\"alsoSearchedContainerNode\">\r\n        <p data-dojo-attach-point=\"alsoSearchedTitleNode\"></p>\r\n        <div data-dojo-attach-point=\"alsoSearchedGridNode\"></div>\r\n    </div>\r\n</div>\r\n"}});
﻿define("epi-find/widget/PhraseDashboardDialog", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/dom-class",
    "dojo/dom-attr",

    "dojo/store/Memory",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dojox/html/entities",

    "dgrid/OnDemandGrid",

    "epi/shell/widget/dialog/Dialog",

    "epi-saas-base/widgets/_NotificationMixin",
    "epi-saas-base/widgets/_GridNumberedColumnMixin",

    "dojo/i18n!./nls/PhraseDashboardDialog",
    "dojo/text!./templates/PhraseDashboardDialog.html"
], function(
        declare,
        lang,
        when,
        domClass,
        domAttr,

        MemoryStore,

        _WidgetBase,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,

        entities,

        OnDemandGrid,

        Dialog,
        _NotificationMixin,
        _GridNumberedColumnMixin,

        i18n,
        template) {

    var bold = function(text) { return "<strong>"+text+"</strong>"; };
    var DialogContent = declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {

        model: null,

        i18n: i18n,

        templateString: template,

        dialogTitle: null,

        mostClickedTitle: null,
        _setMostClickedTitleAttr: {node: "mostClickedTitleNode", type: "innerHTML"},

        alsoSearchedTitle: null,
        _setAlsoSearchedTitleAttr: {node: "alsoSearchedTitleNode", type: "innerHTML"},

        showMostClicked: true,
        _setShowMostClickedAttr: function(value) {
            if (value)
            {
                domClass.add(this.alsoSearchedContainerNode, "epi-column");
                domClass.remove(this.mostClickedContainerNode, "epi-hidden");
            }
            else {
                domClass.remove(this.alsoSearchedContainerNode, "epi-column");
                domClass.add(this.mostClickedContainerNode, "epi-hidden");
            }
            this._set("showMostClicked", value);
        },

        showAlsoSearched: true,
        _setShowAlsoSearchedAttr: function(value) {
            if (value)
            {
                domClass.add(this.mostClickedContainerNode, "epi-column");
                domClass.remove(this.alsoSearchedContainerNode, "epi-hidden");
            }
            else {
                domClass.remove(this.mostClickedContainerNode, "epi-column");
                domClass.add(this.alsoSearchedContainerNode, "epi-hidden");
            }
            this._set("showAlsoSearched", value);
        },

        // query: string
        //      The search query that this dialog is currently showing, should be set externally.
        query: null,
        _setQueryAttr: function(value) {
            this._set("query", value);
            if (this.showMostClicked) {
                this._updateMostClicked();
            }
            if (this.showAlsoSearched) {
                this._updateAlsoSearched();
            }
        },

        _hitsStore: null,
        _hitGrid: null,
        _relatedQueriesStore: null,
        _relatedQueriesGrid: null,

        postCreate: function() {
            this.inherited(arguments);
            this._createGrids();
        },

        onError: function() {
            // summary:
            //      A callback for errors handling
        },

        _createGrids: function() {
            this._hitsStore = new MemoryStore();
            var NumberedGrid = declare([OnDemandGrid, _GridNumberedColumnMixin]);
            this._hitGrid = new NumberedGrid({
                    numberedColumnId: "phrase",
                    "class": "epi-plain-grid  epi-plain-grid--no-border  epi-vertical-spacer  epi-grid-max-height--700",
                    columns: {
                        phrase: {
                            field: "name",
                            formatter: function (value) {
                                if (!value) {
                                    return "<span class='epi-page-not-found'>" + i18n.notFound + "</span>";
                                }
                                return value;
                            },
                            label: i18n.searchResult,
                            sortable: false
                        },
                        count: {
                            field: "count",
                            label: i18n.clicks,
                            className: "epi-grid-column--centered  epi-positive",
                            sortable: false
                        }
                    },
                    noDataMessage: i18n.noResults,
                    store: this._hitsStore
            }, this.mostClickedGridNode);
            this.own(this._hitGrid);

            this._relatedQueriesStore = new MemoryStore();
            this._relatedQueriesGrid = new NumberedGrid({
                    numberedColumnId: "phrase",
                    "class": "epi-plain-grid  epi-plain-grid--no-border  epi-vertical-spacer  epi-grid-max-height--700",
                    columns: {
                        phrase: {
                            field: "query",
                                label: i18n.searchPhrase,
                            sortable: false
                        },
                        count: {
                            field: "count",
                                label: i18n.numberOfSearches,
                                className: "epi-grid-column--centered  epi-positive",
                                sortable: false
                        }
                    },
                    noDataMessage: i18n.noResults,
                    selectionMode: "toggle",
                    store: this._relatedQueriesStore
            }, this.alsoSearchedGridNode);
            this.own(this._relatedQueriesGrid);
        },

        _updateMostClicked: function() {
            var self = this, query = this.query;
            when(this.model.topHitStore.query({
                    size: 5,
                    query: query
                }),
                function(results) {
                    self.set("mostClickedTitle",
                        lang.replace(i18n.templates_mostClicked,
                            {clicks: bold(results.length), phrase: bold(entities.encode(query))}));

                    self._hitsStore.setData(results);
                    self._hitGrid.refresh();
                },
                function(error){
                    self._hitsStore.setData([]);
                    self._hitGrid.refresh();
                    self.onError(error);
                }
            );
        },

        _updateAlsoSearched: function() {
            var self = this;
            when(this.model.topQueryStore.query({
                    type: "related",
                    previousQuery: self.query,
                    size: 5
                }),
                function(results) {
                    self._relatedQueriesStore.setData(results);
                    self._relatedQueriesGrid.refresh();
                },
                function(error) {
                    self._relatedQueriesStore.setData([]);
                    self._relatedQueriesGrid.refresh();
                    self.onError(error);
                }
            );
            this.set("alsoSearchedTitle",
                lang.replace(i18n.templates_alsoSearched, {phrase: bold(entities.encode(self.query))}));

        }
    });

    return declare([Dialog, _NotificationMixin], {
        model: null,

        // errors: Array
        //      Holds array of errors that arise but wasn't shown yet to the user.
        errors: null,

        query: null,
        _setQueryAttr: function(value) {
            this.dialogContent.set("query", value);
            this.set("title", lang.replace(i18n.templates_title, {phrase: bold(entities.encode(value))}));
            domAttr.set(this.titleBar, "title", lang.replace(i18n.templates_title, {phrase: entities.encode(value)}));
            this._set("query", value);
        },

        showMostClicked: true,
        _setShowMostClickedAttr: function(value) {
            this.dialogContent.set("showMostClicked", value);
            this._set("showMostClicked", value);
            this._changeWidth();
        },

        showAlsoSearched: true,
        _setShowAlsoSearchedAttr: function(value) {
            this.dialogContent.set("showAlsoSearched", value);
            this._set("showAlsoSearched", value);
            this._changeWidth();
        },

        dialogClass:"epi-phrase-dashboard-dialog",
        dialogContent: null,
        defaultActionsVisible: false,

        getActions: function() {
            return [{
                label: i18n.close,
                title: null,
                settings: { type: "submit", "class": "Salt" }
            }];
        },

        constructor: function(options) {
            var self = this;
            this.errors = [];
            declare.safeMixin(this, options);
            this.dialogContent = new DialogContent({
                model: this.model,
                dialog: this,
                onError: function(error) {
                    if (self.open) {
                        self.showError(error);
                    }
                    else {
                        // Since this is a modal dialog we can't show error messages
                        // as another model confirm dialog until this dialog is opened.
                        // So we save error for later usage.
                        self.errors.push(error);
                    }
                }
            });
        },

        postCreate: function() {
            this.inherited(arguments);
            this.set("content", this.dialogContent);
        },

        show: function() {
            //  summary:
            //      Shows the dialog. After the dialog is shown, displays error messages that occurred meanwhile.
            var result = this.inherited(arguments), self = this;
            when(result, function() {
                var error;
                while ((error = self.errors.shift())) {
                    self.showError(error);
                }
            });
            return result;
        },

        _changeWidth: function () {
            if (this.showMostClicked && this.showAlsoSearched) {
                domClass.remove(this.domNode, "epi-phrase-dashboard-dialog__narrow");
            }
            else {
                domClass.add(this.domNode, "epi-phrase-dashboard-dialog__narrow");
            }
        }

    });
});
