require({cache:{
'url:epi-find/widget/templates/RelatedQueries.html':"<div>\r\n    <p class=\"epi-view--description\">${i18n.description}</p>\r\n    <div class=\"error\" data-dojo-attach-point=\"errorNode\"></div>\r\n    <form data-dojo-attach-point=\"relatedQueriesForm\"></form>\r\n    <p class=\"epi-help\">${i18n.help_grid}</p>\r\n    <div class=\"epi-grid-title-search\" data-dojo-attach-point=\"relatedQueriesHeader\">\r\n        <h1>${i18n.header}</h1>\r\n        <div class=\"epi-search-box\">\r\n            <input type=\"text\" name=\"query\"\r\n                   class=\"epi-search-input\"\r\n                   data-dojo-type=\"dijit/form/TextBox\"\r\n                   data-dojo-props=\"trim: true, intermediateChanges: true\"\r\n                   data-dojo-attach-point=\"searchNode\" placeholder=\"${i18n.search}\" />\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"relatedQueriesGrid\" class=\"epi-related-query-grid epi-plain-grid  epi-plain-grid--no-border  epi-grid-max-height--700\"></div>\r\n</div>"}});
define("epi-find/widget/RelatedQueries", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/on",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_FocusMixin",
    "dijit/form/TextBox",

    "dojox/mvc/at",

    "epi-saas-base/Sticker",
    "epi-saas-base/StickyContainer",

    "./_SiblingFocusMixin",
    "./_ActionableMixin",
    "./_DisabledViewMixin",
    "./RelatedQueriesForm",
    "./RelatedQueriesGrid",

    "dojo/i18n!./nls/RelatedQueries",
    "dojo/text!./templates/RelatedQueries.html"

],
    function (
        declare,
        lang,
        when,
        on,
        _WidgetBase,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _FocusMixin,
        TextBox,
        at,
        Sticker,
        StickyContainer,
        _SiblingFocusMixin,
        _ActionableMixin,
        _DisabledViewMixin,
        RelatedQueriesForm,
        RelatedQueriesGrid,
        i18n,
        template) {

        // module:
        //      epi-find/widget/RelatedQueries

        return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _FocusMixin,
                       _SiblingFocusMixin, _ActionableMixin, _DisabledViewMixin], {
            // summary:
            //     Related Queries view.

            templateString: template,

            i18n: i18n,

            model: null,

            _form: null,
            _grid: null,

            _searchText: null,

            _searchUpdateTimeout: 400,
            _searchUpdateTimer: null,

            takeAction: function (actions, params) {
                if (params && params.phrases) {
                    this._form.reset();
                    this.model.ctrl.set("query", decodeURIComponent(params.phrases));
                }
                this._grid.refresh();
            },

            postCreate: function () {
                this.inherited(arguments);
                var self = this;

                var form = this._form = new RelatedQueriesForm({
                    model: this.model,
                    afterSubmit: function() {
                        self._grid.refresh();
                    }
                }, this.relatedQueriesForm);
                this.own(this._form);

                this._grid = new RelatedQueriesGrid({
                    "class": "epi-plain-grid epi-plain-grid--no-border",
                    showHeader: true,
                    store: this.model.store,
                    query: this.model.gridQuery,
                    model: this.model,
                    loadingMessage: i18n.dataLoading,
                    showLoadingMessage: true,
                    onEdit: function (args) {
                        form.edit(args.id, args.suggestion);
                    }
                }, this.relatedQueriesGrid);

                this.own(
                    this._grid,
                    this.model.watch("gridQuery", function(name, oldValue, newValue) {
                        self._grid.set("query", newValue);
                    }),
                    this.searchNode.watch("value", function(name, oldValue, newValue) {
                        self._searchText = newValue;
                        self._delayedReload();
                    })
                );
            },

            _delayedReload: function() {
                //  summary:
                //      Updates grids query with text from the search textbox with delay.
                if (this._searchUpdateTimer) {
                    clearTimeout(this._searchUpdateTimer);
                }
                this._searchUpdateTimer = setTimeout(lang.hitch(this, function () {
                    this._searchUpdateTimer = null;
                    this.model.set("searchText", this._searchText ? "(@ |\"\")" + this._searchText.toLowerCase() + "." : "");
                }), this._searchUpdateTimeout);
            },

            startup: function () {
                this.inherited(arguments);
                var scrollNode = this.scrollNode || this.domNode.parentNode;
                this._form.startup();
                this._grid.set("scrollNode", scrollNode);
                this._grid.startup();

                this.own(
                    new StickyContainer({
                        scrollNode: scrollNode,
                        stickers: [
                            new Sticker({ domNode: this.relatedQueriesHeader, offset: {top: 0}, limitNode: this._grid.domNode, subscribe: false}),
                            new Sticker({ domNode: this._grid.headerNode, offset: {top: 0}, limitNode: this._grid.domNode, subscribe: false})
                        ]
                    })
                );
            },

            refresh: function () {
                this._grid.refresh();
                this._form.reset();
            }
        });
    });
