require({cache:{
'url:epi-find/widget/templates/RelatedQueriesForm.html':"<form data-dojo-attach-point='containerNode' data-dojo-attach-event='onreset:_onReset,onsubmit:_onSubmit' class='epi-formsWidgetWrapper'>\r\n    <ol class='epi-formsWidgetWrapper'>\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" data-dojo-attach-point=\"phraseListItem\">\r\n            <input id=\"phrase\" data-dojo-attach-point=\"phraseField\" data-dojo-type=\"epi-find/widget/PhraseValidationTextBox\" data-dojo-props=\"required:true, intermediateChanges: true, invalidMessage: '${i18nPhraseHelp}'\"/>\r\n        </li>\r\n\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" data-dojo-attach-point=\"suggestionsListItem\">\r\n            <input id=\"suggestions\" data-dojo-attach-point=\"suggestionsField\" data-dojo-type=\"epi-find/widget/PhraseValidationTextBox\" data-dojo-props=\"required:true, intermediateChanges: true, phraseDelimiter:',', invalidMessage: '${i18nSuggestionHelp}'\" />\r\n        </li>\r\n\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" class=\"epi-formsRow--align-right\">\r\n            <input data-dojo-attach-point=\"submitButton\" type=\"submit\" data-dojo-type=\"dijit/form/Button\" class=\"epi-primary\" />\r\n            <input data-dojo-attach-point=\"resetButton\" type=\"reset\" data-dojo-type=\"dijit/form/Button\" />\r\n        </li>\r\n    </ol>\r\n</form>\r\n"}});
﻿define("epi-find/widget/RelatedQueriesForm", [
    "dojo/_base/declare",
    "dojo/_base/config",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    "dojox/mvc/at",
    "dijit/form/Form",
    "dijit/form/_TextBoxMixin",
    "dijit/_WidgetsInTemplateMixin",
    // widgets used in the template
    "dijit/form/Button",
    "dijit/form/ValidationTextBox",
    "./PhraseValidationTextBox",
    "epi-saas-base/form/FormListItem",
    "epi-saas-base/widgets/_NotificationMixin",
    "epi-saas-base/UnicodeLetterRegexp",
    "epi-saas-base/widgets/_ActionButtonsMixin",

    "epi/shell/widget/dialog/Dialog",
    "dojo/text!./templates/RelatedQueriesForm.html",
    "dojo/i18n!./nls/RelatedQueries"

],
    function(declare,
             config,
             event,
             lang,
             topic,
             when,

             at,

             Form,
             _TextBoxMixin,
             _WidgetsInTemplateMixin,
             Button,
             ValidationTextBox,
             PhraseValidationTextBox,
             FormListItem,
             _NotificationMixin,
             UnicodeLetterRegExp,
             _ActionButtonsMixin,

             Dialog,
             template,
             i18n
        ) {
        // module:
        //      epi-find/widget/RelatedQueriesForm
        return declare([Form, _WidgetsInTemplateMixin, _NotificationMixin, _ActionButtonsMixin], {

            baseClass: "",
            model: null,
            i18n: i18n,
            templateString: template,

            i18nPhraseHelp: i18n.help_phrase,
            i18nSuggestionHelp: i18n.help_suggestions,

            // phraseValidationRegExp: string
            //      A string with regular expression defining a phrase in unicode
            phraseValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-]("+UnicodeLetterRegExp+"|[0-9&'+#$_.\\-\\s])*",

            // suggestionValidationRegExp: string
            //      A string with regular expression defining a comma-separated list of phrases in unicode
            suggestionValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-]("+UnicodeLetterRegExp+"|[0-9&'+#$_.\\-\\s,])*",

            phraseField: null,
            suggestionsField: null,

            postCreate: function() {
                this.inherited(arguments);
                this.phraseListItem.set("label", i18n.fields_phrase);
                this.phraseListItem.set("help", i18n.help_phrase);
                this.suggestionsListItem.set("label", i18n.fields_suggestions);
                this.suggestionsListItem.set("description", i18n.separateMultipleSuggestions);
                this.suggestionsListItem.set("help", i18n.help_suggestions);
                this.submitButton.set("label", i18n.buttons_add);
                this.resetButton.set("label", i18n.buttons_cancel);
            },

            startup: function () {
                this.inherited(arguments);

                var self = this;

                this.actionButtons = [this.submitButton, this.resetButton];
                this.enabledWhenNoChangesButtons = [this.resetButton];

                this.phraseField.set("value", at(this.model.ctrl, "query"));
                this.phraseField.set("pattern", this.phraseValidationRegExp);
                this.suggestionsField.set("value", at(this.model.ctrl, "suggestion"));
                this.suggestionsField.set("pattern", this.suggestionValidationRegExp);
                this.reset();


                this.own(this.watchDataChanges(this.model.ctrl));
            },

            onSubmit: function (e) {
                var self = this;
                event.stop(e);
                if (!this.validate()) {
                    return ;
                }
                this.submitButton.focus();
                this.indicateInProgress(this.submitButton);
                when(this.model.saveChanges(),
                    function (results) {
                        self.reset();
                        self.showSuccess(i18n.savedMessage);
                        topic.publish(config.intents.view.relatedQueries);
                        self.afterSubmit({items: results});
                        self.indicateSuccess();
                        self.phraseField.focus();
                    },
                    function (error) {
                        self.showError(error);
                        self.indicateError();
                        self.afterSubmit({ items: [] });
                    }
                );
            },

            onReset: function() {
                this.model.ctrl.reset();
                this.model.ctrl.empty();
                this.submitButton.set("label", i18n.buttons_add);
                return this.inherited(arguments);
            },

            edit: function(id, suggestion) {
                if (this.editMode) {
                    this.reset();
                }

                when(this.model.ctrl.getStore(id),
                    lang.hitch(this, function() {
                        this.suggestionsField.focus();
                        var selectionStart = this.suggestionsField.value.indexOf(suggestion);
                        _TextBoxMixin.selectInputText(this.suggestionsField.textbox, selectionStart, selectionStart + suggestion.length);
                        this.submitButton.set("label", i18n.buttons_save);
                        this.set("hasChanges", false);
                    }),
                    lang.hitch(this, function(error) {
                        this.showError(error);
                    })
                );

            },

            submit: function() {
                // summary:
                //      pragmatically submit form if and only if the `onSubmit` returns true
                if (this.onSubmit() === false) {
                    return;
                }
                this.originalContainerNode.submit();
            },

            afterSubmit: function(/*Object*/ e) {
                // summary:
                //      Refresh callback
                // e: Object
                //      Callback arguments, e.items contains an array of submitted entities
            }

        });

    });
