require({cache:{
'url:epi-find/widget/templates/Schedule.html':"<div>\r\n    <div>\r\n        <input data-dojo-type=\"dijit/form/RadioButton\" data-dojo-attach-point=\"noSchedule\" data-dojo-props=\"checked: true\" id=\"noSchedule\" name=\"schedule\"  /><label for=\"noSchedule\" >${i18n.noSchedule}</label>\r\n    </div>\r\n    <div>\r\n        <span class=\"epi-formsRow__input-wrapper--inline\">\r\n            <input data-dojo-type=\"dijit/form/RadioButton\" data-dojo-attach-point=\"dailySchedule\" id=\"dailySchedule\" name=\"schedule\" /><label data-dojo-attach-point=\"dailyNode\"></label>\r\n        </span>\r\n        <span class=\"epi-formsRow__input-wrapper--inline\">\r\n            <input data-dojo-type=\"dijit/form/RadioButton\" data-dojo-attach-point=\"weeklySchedule\" id=\"weeklySchedule\" name=\"schedule\" /><label data-dojo-attach-point=\"weeklyNode\"></label>\r\n        </span>\r\n        <span class=\"epi-formsRow__input-wrapper--inline\">\r\n            <input data-dojo-type=\"dijit/form/RadioButton\" data-dojo-attach-point=\"customSchedule\" id=\"customSchedule\" name=\"schedule\"/><label data-dojo-attach-point=\"customNode\"></label>\r\n        </span>\r\n        <p class=\"epi-secondaryText\">${i18n.daylightSavings}</p>\r\n    </div>\r\n</div>\r\n"}});
define("epi-find/widget/Schedule", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/date/locale",
    "dojo/_base/event",

    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/store/Memory",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/form/Select",
    "dijit/form/ComboBox",
    "dijit/form/RadioButton",
    "dijit/form/TimeTextBox",
    "dijit/form/ValidationTextBox",
    "dojox/lang/functional",
    "dojox/validate",

    "dojo/text!./templates/Schedule.html",
    "dojo/i18n!./nls/Schedule"
],
    function( declare, lang, array, locale, event,
             domAttr, domClass,
             Memory,
             _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin,

             Select, ComboBox, RadioButton, TimeTextBox, ValidationTextBox,
             functional, validate,
             template, i18n
        ) {

        var DailyLabel = declare([_WidgetBase, _TemplatedMixin], {
            templateString: "<label data-dojo-attach-point=\"label\">"+ i18n.dailySchedule
                .replace("{time}", "<span data-dojo-attach-point=\"timeNode\"></span> ")+"</label>",
            time: null,
            inputId: null,
            schedule: null,
            _setScheduleAttr: function(value) {
                this.time.set("value", value ? value.time : "");
                this._set("schedule", value);
            },
            disabled: false,
            _setDisabledAttr: function(value) {
                if (this.time) {
                    this.time.set("disabled", value);
                }
                this._set("disabled", value);
            },
            postCreate: function() {
                this.inherited(arguments);
                this.containerNode = this.domNode;
                var self = this;
                this.time = new TimeTextBox({
                    "class": "epi-chromeless epi-chromeless--with-arrow epi-flat",
                    style: { width: "100px" },
                    required: true,
                    disabled: this.disabled
                }, this.timeNode);
                this.own(
                    this.time,
                    this.time.watch("value", function() {
                        if (self.time.isValid()) {
                            self._set("schedule", {type: "daily", time: self.time.get("value")});
                        }
                    })
                );
                domAttr.set(this.label, "for", this.inputId);
            }
        });

        var WeeklyLabel = declare([_WidgetBase, _TemplatedMixin], {
            templateString: "<label data-dojo-attach-point=\"label\">"+ i18n.weeklySchedule
                .replace("{time}", "<span data-dojo-attach-point=\"timeNode\"></span>")
                .replace("{dayOfTheWeek}", "<span data-dojo-attach-point=\"dayOfTheWeekNode\"></span>")+"</label>",
            time: null,
            dayOfTheWeek: null,
            inputId: null,
            schedule: null,
            _setScheduleAttr: function(value) {
                this.time.set("value", value ? value.time : "");
                this.dayOfTheWeek.set("value", value ? value.dayOfTheWeek : "");
                this._set("schedule", value);
            },
            disabled: false,
            _setDisabledAttr: function(value) {
                if (this.time) {
                    this.time.set("disabled", value);
                }
                if (this.dayOfTheWeek) {
                    this.dayOfTheWeek.set("disabled", value);
                }
                this._set("disabled", value);
            },
            updateSchedule: function() {
                if (this.time.isValid() && this.dayOfTheWeek.isValid()){
                    this._set("schedule", {type: "weekly", time: this.time.get("value"), dayOfTheWeek: this.dayOfTheWeek.get("value")});
                }
            },
            postCreate: function() {
                this.inherited(arguments);
                this.containerNode = this.domNode;
                this.time = new TimeTextBox({
                    "class": "epi-chromeless epi-chromeless--with-arrow epi-flat",
                    style: { width: "100px" },
                    required: true,
                    disabled: this.disabled
                }, this.timeNode);
                this.own(
                    this.time,
                    this.time.watch("value", lang.hitch(this, this.updateSchedule))
                );
                var weekdaysSelectOptions = array.map([i18n.weekdays_monday, i18n.weekdays_tuesday, i18n.weekdays_wednesday, i18n.weekdays_thursday, i18n.weekdays_friday, i18n.weekdays_saturday, i18n.weekdays_sunday], function(item, index) {
                    return { label: item, value: (index + 1).toString() };
                });
                this.dayOfTheWeek = new Select({
                    "class": "epi-chromeless epi-chromeless--with-arrow epi-flat",
                    options: weekdaysSelectOptions,
                    disabled: this.disabled
                }, this.dayOfTheWeekNode);
                this.own(
                    this.dayOfTheWeek,
                    this.dayOfTheWeek.watch("value", lang.hitch(this, this.updateSchedule))
                );
                domAttr.set(this.label, "for", this.inputId);
            }
        });

        var CustomLabel = declare([_WidgetBase, _TemplatedMixin], {
            templateString: "<label data-dojo-attach-point=\"label\" class=\"epi-hidden\">"+ i18n.customSchedule
                .replace("{cronSchedule}", "<span data-dojo-attach-point=\"valueNode\"></span> ")+"</label>",
            cronSchedule: null,
            inputId: null,
            schedule: null,
            _setScheduleAttr: function(value) {
                this.cronSchedule.set("value", value ? value.cronSchedule : "");
                this._set("schedule", value);
            },
            disabled: false,
            _setDisabledAttr: function(value) {
                if (this.cronSchedule) {
                    this.cronSchedule.set("disabled", value);
                }
                this._set("disabled", value);
            },

            postCreate: function() {
                this.inherited(arguments);
                this.containerNode = this.domNode;
                var self = this;

                this.cronSchedule = new ValidationTextBox({
                    "class": "epi-chromeless epi-flat",
                    required: true,
                    disabled: this.disabled
                }, this.valueNode);
                this.own(
                    this.cronSchedule,
                    this.cronSchedule.watch("value", function() {
                        if (self.cronSchedule.isValid()) {
                            self._set("schedule", {type: "custom", cronSchedule: self.cronSchedule.get("value")});
                        }
                    })
                );
                domAttr.set(this.label, "for", this.inputId);
            }
        });

        // module:
        //      epi-find/widget/Schedule

        return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
            // summary:
            //     Connector settings schedule

            i18n: i18n,

            model: null,

            daily: null,
            weekly: null,
            custom: null,

            schedule: null,
            // summary:
            //      Schedule as an object with a "cron" property containing a string in cron format (http://en.wikipedia.org/wiki/Cron#Predefined_scheduling_definitions)
            _setScheduleAttr: function(value) {

                if (!value || !value.cron) {
                    this.noSchedule.set("checked", true);
                    this._hideCustomField();
                    this._set("schedule", value);
                }
                else {
                    if (this.schedule && value.cron === this.schedule.cron) {
                        return;
                    }
                    this._set("schedule", value);
                    this._hideCustomField();

                    var schedule = this.model.changeScheduleTZ(this.model.parseCronSchedule(value.cron), -this.model.offset);
                    if (schedule.type === "daily") {
                        this.dailySchedule.set("checked", true);
                        this.daily.set("schedule", schedule);
                    }
                    else if (schedule.type === "weekly") {
                        this.weeklySchedule.set("checked", true);
                        this.weekly.set("schedule", schedule);
                    }
                    else if (schedule.type === "custom") {
                        this._showCustomField();
                        this.customSchedule.set("checked", true);
                        this.custom.set("schedule", schedule);
                    }
                }
            },

            templateString: template,

            postCreate: function() {
                this.inherited(arguments);
                var self = this;
                this.containerNode = this.domNode;
                this.daily = new DailyLabel({inputId: "dailySchedule", disabled: true}, this.dailyNode);
                this.weekly = new WeeklyLabel({inputId: "weeklySchedule", disabled: true}, this.weeklyNode);
                this.custom = new CustomLabel({inputId: "customSchedule", disabled: true}, this.customNode);

                this.own(
                    this.daily,
                    this.weekly,
                    this.custom,
                    this.daily.watch("schedule", lang.hitch(this, function() { this._updateSchedule(this.dailySchedule); })),
                    this.weekly.watch("schedule", lang.hitch(this, function() { this._updateSchedule(this.weeklySchedule); })),
                    this.custom.watch("schedule", lang.hitch(this, function() { this._updateSchedule(this.customSchedule); })),
                    this.noSchedule.watch("checked", lang.hitch(this, function(prop, oldValue, newValue) {
                        if (newValue) {
                           this._updateSchedule();
                        }
                    })),
                    this.dailySchedule.watch("checked", function(prop, oldValue, newValue) {
                        self.daily.set("disabled", !newValue);
                    }),
                    this.weeklySchedule.watch("checked", function(prop, oldValue, newValue) {
                        self.weekly.set("disabled", !newValue);
                    }),
                    this.customSchedule.watch("checked", function(prop, oldValue, newValue) {
                        self.custom.set("disabled", !newValue);
                    })
                );
                this._hideCustomField();
            },

            _updateSchedule: function(checkbox) {
                var result;
                if (checkbox) {
                    checkbox.set("checked", true);
                }

                if (this.noSchedule.get("checked")) {
                    result = null;
                }
                else if (this.dailySchedule.get("checked")) {
                    result = this.daily.get("schedule");
                }
                else if (this.weeklySchedule.get("checked")) {
                    result = this.weekly.get("schedule");
                }
                else if (this.customSchedule.get("checked")) {
                    result = this.custom.get("schedule");
                }
                this.set("schedule", this.model.serialiseToCronSchedule(this.model.changeScheduleTZ(result, this.model.offset)));
            },

            _showCustomField: function() {
                this.customSchedule.set("disabled", false);
                this.custom.set("disabled", false);

                domClass.remove(this.customSchedule.domNode, "epi-hidden");
                domClass.remove(this.custom.domNode, "epi-hidden");
            },

            _hideCustomField: function() {
                this.customSchedule.set("disabled", true);
                this.custom.set("disabled", true);

                domClass.add(this.customSchedule.domNode, "epi-hidden");
                domClass.add(this.custom.domNode, "epi-hidden");
            }

        });

    });
