require({cache:{
'url:epi-find/widget/templates/SynonymForm.html':"<form data-dojo-attach-point='containerNode' data-dojo-attach-event='onreset:_onReset,onsubmit:_onSubmit' class='epi-formsWidgetWrapper epi-vertical-spacer--double'>\r\n    <ol class='epi-formsWidgetWrapper'>\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" data-dojo-attach-point=\"phraseFieldListItem\">\r\n            <input id=\"phraseField\" data-dojo-attach-point=\"phraseField\" data-dojo-type=\"epi-find/widget/PhraseValidationTextBox\"\r\n                   data-dojo-props=\"required:true, intermediateChanges: true, phraseDelimiter:',', invalidMessage: '${i18nPhraseHelp}'\" />\r\n        </li>\r\n\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" data-dojo-attach-point=\"synonymFieldListItem\">\r\n            <input id=\"synonymField\" data-dojo-attach-point=\"synonymField\" data-dojo-type=\"epi-find/widget/PhraseValidationTextBox\"\r\n                   data-dojo-props=\"required:true, intermediateChanges: true, invalidMessage: '${i18nSynonymHelp}'\" />\r\n            <p class=\"epi-help\">${i18nSynonymHelp}</p>\r\n        </li>\r\n\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" data-dojo-props=\"class: 'epi-formsRow--fullWidthInput'\" data-dojo-attach-point=\"bidirectionalCheckboxListItem\">\r\n            <input id=\"bidirectionalCheckbox\" data-dojo-attach-point=\"bidirectionalCheckbox\" data-dojo-type=\"dijit/form/CheckBox\" />\r\n            <p class=\"epi-help\">${i18n.help_bidirectional}</p>\r\n        </li>\r\n\r\n        <li data-dojo-type=\"epi-saas-base/form/FormListItem\" class=\"epi-formsRow--align-right\">\r\n            <input data-dojo-attach-point=\"submitButton\" type=\"submit\" data-dojo-type=\"dijit/form/Button\" class=\"epi-primary\" />\r\n            <input data-dojo-attach-point=\"resetButton\" type=\"reset\" data-dojo-type=\"dijit/form/Button\" />\r\n        </li>\r\n    </ol>\r\n</form>\r\n"}});
﻿define("epi-find/widget/SynonymForm", [
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/config",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/topic",
    "dojo/when",

    "dijit/form/Form",
    "dijit/form/CheckBox",
    "dijit/form/Button",
    "dijit/form/ValidationTextBox",

    "dijit/_WidgetsInTemplateMixin",

    "dojox/mvc/at",

    "epi-saas-base/form/FormListItem",
    "epi-saas-base/UnicodeLetterRegexp",
    "epi-saas-base/widgets/_NotificationMixin",
    "epi-saas-base/widgets/_ActionButtonsMixin",
    "../ConfigModel",
    "../util/arrayx",

    "dojo/text!./templates/SynonymForm.html",
    "dojo/i18n!./nls/Synonyms"

], function(
    declare,
    event,
    config,
    lang,
    array,
    topic,
    when,

    Form,
    CheckBox,
    Button,
    ValidationTextBox,

    _WidgetsInTemplateMixin,

    at,

    FormListItem,
    UnicodeLetterRegExp,
    _NotificationMixin,
    _ActionButtonsMixin,
    ConfigModel,
    arrayx,

    template,
    i18n
    ) {
    return declare([Form, _WidgetsInTemplateMixin, _NotificationMixin, _ActionButtonsMixin], {

        "class": "epi-formsWidgetWrapper",
        ctrl: null,
        templateString: template,
        i18n: i18n,

        i18nPhraseHelp: i18n.help_phrase,
        i18nSynonymHelp: i18n.help_synonym,

        // phraseValidationRegExp: string
        //      A string with regular expression defining a comma-separated list of words in unicode
        phraseValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-]((("+UnicodeLetterRegExp+"|[0-9&+#$'_.\\-])+)(,\\s*)*)*",
        multiPhraseValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-]((("+UnicodeLetterRegExp+"|[0-9&+#$'_.\\-])*[\\s]?){1,3}\\s*,\\s*)*(("+UnicodeLetterRegExp+"|[0-9&+#$'_.\\-])*[\\s]?){1,3}",

        // synonymValidationRegExp: string
        //      A string with regular expression defining a single word in unicode
        synonymValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-]("+UnicodeLetterRegExp+"|[0-9&+#$'_.\\-])*",
        multiSynonymValidationRegExp: "[^~`!@%^*()\\[\\]\\{\\}:;'|/<>?_-](("+UnicodeLetterRegExp+"|[0-9&+#$'_.\\-])*[\\s]?){1,3}",


        phraseField: null,
        synonymField: null,
        bidirectionalCheckbox: null,
        submitButton: null,

        _hasMultiToken: false,

        postMixInProperties: function () {
            this.inherited(arguments);
            if (ConfigModel.getValue("api.synonyms.multi_token") === true) {
                this.i18nPhraseHelp = this.i18n.help_multiPhrase;
                this.i18nSynonymHelp = this.i18n.help_multiSynonym;
            }
        },

        postCreate: function() {
            this.inherited(arguments);

            this.phraseFieldListItem.set("label", i18n.fields_phrase);
            this.phraseFieldListItem.set("description", i18n.separateMultiplePhrases);
            this.phraseFieldListItem.set("help", this.i18nPhraseHelp);
            this.synonymFieldListItem.set("label", i18n.fields_synonym);
            this.bidirectionalCheckboxListItem.set("label",i18n.fields_bidirectional);
            this.submitButton.set("label", i18n.addSynonym);
            this.resetButton.set("label", i18n.cancel);

            this.actionButtons = [this.submitButton, this.resetButton];
            this.enabledWhenNoChangesButtons = [this.resetButton];

            var compareValidator = lang.hitch(this, this.validatePhraseSynonymNotEqual);
            var phraseFieldValidator = lang.hitch(this.phraseField, this.phraseField.validator);
            this.phraseField.validator = function (value, constraints) {
                return  phraseFieldValidator(value, constraints) &&
                    compareValidator(value, constraints);
            };

            var synonymFieldValidator = lang.hitch(this.synonymField, this.synonymField.validator);
            this.synonymField.validator = function (value, constraints) {
                return synonymFieldValidator(value, constraints) &&
                    compareValidator(value, constraints);
            };

            this._hasMultiToken = ConfigModel.getValue("api.synonyms.multi_token") === true;

            this.phraseField.set("value", at(this.ctrl, "phrase"));
            this.phraseField.set("pattern", this._hasMultiToken ? this.multiPhraseValidationRegExp : this.phraseValidationRegExp);

            this.synonymField.set("value", at(this.ctrl, "synonym"));
            this.synonymField.set("pattern", this._hasMultiToken ? this.multiSynonymValidationRegExp : this.synonymValidationRegExp);

            this.bidirectionalCheckbox.set("checked", at(this.ctrl, "bidirectional"));

            this.own(this.watchDataChanges(this.ctrl));
        },

        onSubmit: function(e) {
            var self = this;
            event.stop(e);
            if (!this.validate()) {
                return false;
            }
            this.submitButton.focus();
            this.indicateInProgress(this.submitButton);
            when(this.ctrl.commit(), function() {
                    self.reset();
                    self.showSuccess(i18n.savedMessage);
                    self.indicateSuccess();
                    topic.publish(config.intents.view.synonyms);
                    self.phraseField.focus();
                },
                function (error) {
                    self.showError(error, null, i18n.saveErrorTitle);
                    self.indicateError();
                });
        },

        edit: function(synonymId) {
            var self = this;

            if (this.editMode) {
                this.reset();
            }
            when(this.ctrl.getStore(synonymId), function() {
                    self.phraseField.focus();
                    self.submitButton.set("label", i18n.saveSynonym);
                    self.set("hasChanges", false);
                },
                function (error) {
                    self.showError(error);
                }
            );
        },

        onReset: function() {
            this.ctrl.reset();
            this.ctrl.empty();
            this.submitButton.set("label", i18n.addSynonym);
            return this.inherited(arguments);
        },

        submit: function(){
            // summary:
            //      programmatically submit form if and only if the `onSubmit` returns true
            if(this.onSubmit() === false){
                return;
            }
            this.originalContainerNode.submit();
        },

        validatePhraseSynonymNotEqual: function(value, constraints) {
            var phrase = this.phraseField.getValue();
            var synonym = this.synonymField.getValue();
            if (!phrase || !synonym) {
                return true;
            }
            return !arrayx.intersected(this._hasMultiToken ? arrayx.parse(phrase, ",") : phrase, synonym);
        }
    });
});
