require({cache:{
'url:epi-find/widget/templates/Synonyms.html':"<div>\r\n    <p class=\"epi-view--description\">${i18n.description}</p>\r\n    <form data-dojo-attach-point=\"synonymForm\"></form>\r\n    <p class=\"epi-help\">${i18n.help_table}</p>\r\n    <div class=\"epi-grid-title-search\" data-dojo-attach-point=\"synonymsHeader\">\r\n        <h1>${i18n.header}</h1>\r\n        <div class=\"epi-search-box\">\r\n            <input type=\"text\" name=\"query\"\r\n                   class=\"epi-search-input\"\r\n                   data-dojo-type=\"dijit/form/TextBox\"\r\n                   data-dojo-props=\"trim: true, intermediateChanges: true\"\r\n                   data-dojo-attach-point=\"searchNode\" placeholder=\"${i18n.search}\" />\r\n        </div>\r\n    </div>\r\n    <div id=\"synonymgrid\" data-dojo-attach-point=\"synonymGrid\"></div>\r\n</div>"}});
define("epi-find/widget/Synonyms", [
    "dojo/_base/config",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/store/Memory",
    "dojo/store/Observable",
    "dojo/Stateful",
    "dojo/when",

    "dojox/mvc/EditStoreRefController",

    "dijit/_WidgetBase",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_FocusMixin",
    "dijit/MenuItem",
    "dijit/form/TextBox",

    "dgrid/Grid",
    "dgrid/extensions/DijitRegistry",

    "epi-saas-base/Sticker",
    "epi-saas-base/StickyContainer",
    "epi-saas-base/mvc/_CommitReturnMixin",
    "epi-saas-base/mvc/_EmptiableRefControllerMixin",
    "epi-saas-base/widgets/_NotificationMixin",
    "epi-saas-base/widgets/_GridContextMenuMixin",
    "epi-saas-base/widgets/_GridMoreMixin",
    "epi-saas-base/widgets/_AutoLoadScrollMixin",

    "./_SiblingFocusMixin",
    "./_ActionableMixin",
    "./_DisabledViewMixin",

    "./SynonymForm",

    "epi/shell/widget/ContextMenu",
    "epi/shell/dgrid/Formatter",
    "epi-cms/dgrid/formatters",

    "dojo/i18n!./nls/Synonyms",
    "dojo/text!./templates/Synonyms.html"

],
function(config,
        declare,
        lang,
        domConstruct,
        domClass,
        MemoryStore,
        Observable,
        Stateful,
        when,
        EditStoreRefController,
        _WidgetBase,
        _Container,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _FocusMixin,
        MenuItem,
        TextBox,

        Grid,
        DijitRegistry,

         Sticker,
         StickyContainer,
        _CommitReturnMixin,
        _EmptiableRefControllerMixin,
        _NotificationMixin,
        _GridContextMenuMixin,
        _GridMoreMixin,
        _AutoLoadScrollMixin,

        _SiblingFocusMixin,
        _ActionableMixin,
        _DisabledViewMixin,

        SynonymForm,

        ContextMenu,
        Formatter,
        formatters,
        i18n,
        template) {

    // module:
    //      epi-find/widget/Synonyms

    return declare([_WidgetBase, _Container, _TemplatedMixin, _WidgetsInTemplateMixin, _FocusMixin, _SiblingFocusMixin, _ActionableMixin, _DisabledViewMixin, _NotificationMixin], {
        // summary:
        //     Synonyms view.

        templateString: template,

        i18n: i18n,

        store: null,

        ctrl: null,

        _synonymForm: null,

        _searchText: null,

        _searchUpdateTimeout: 400,
        _searchUpdateTimer: null,

        constructor: function() {
            this.store = new Observable(config.dependencies["epi-find.SynonymStore"]);
            this.own(this.store);

        },

        takeAction: function(actions, params) {
            if (params && params.phrases) {
                this._synonymForm.reset();
                this.ctrl.set("phrase", decodeURIComponent(params.phrases));
            }
            this.grid.refresh();
        },

        refresh: function() {
            this.grid.refresh();
            this._synonymForm.reset();
        },

        postCreate: function() {
            this.inherited(arguments);

            var self = this,
                CommitController = declare([EditStoreRefController, _CommitReturnMixin, _EmptiableRefControllerMixin]);

            this.ctrl = new CommitController({
                store: this.store,
                originalModel: new Stateful({ phrase: null, synonym: null, bidirectional: false }),
                emptyModel:  new Stateful({ phrase: null, synonym: null, bidirectional: false })
            });

            this._synonymForm = new SynonymForm({
                ctrl: this.ctrl
            }, this.synonymForm);
            this._synonymForm.reset();
            this.own(this._synonymForm);
            this._synonymForm.startup();

            var SynonymGrid = declare([Grid, _GridMoreMixin, _AutoLoadScrollMixin, Formatter, _GridContextMenuMixin, _NotificationMixin], {
                    constructor: function() {
                        // Sets the loader (#loadNextPage, available in _GridMoreMixn) to be used by the _AutoLoadScrollMixin
                        this.loader = lang.hitch(this, this.loadNextPage);
                    },
                    i18n: i18n,
                    contextMenu: new ContextMenu(),
                    showHeader: true,
                    margin: 140,
                    columns: {
                        phrase: {
                            label: i18n.fields_phrase,
                            sortable: true
                        },
                        bidirectional: {
                            label: " ",
                            renderCell: function (object, value, node) {
                                var directionNode = domConstruct.create("span", {
                                    "class": "dijitReset dijitInline dijitIcon",
                                    title: value ? i18n.fields_bidirectional : i18n.fields_oneWay
                                });
                                domClass.add(directionNode, value ? "epi-gridIconBiDirectional" : "epi-gridIconDirectional");
                                domConstruct.place(directionNode, node);
                            },
                            sortable: false,
                            className: "epi-grid--5  epi-grid-column--centered"
                        },
                        synonym: {
                            label: i18n.fields_synonym,
                            sortable: true
                        },
                        context: {
                            label: " ",
                            sortable: false,
                            formatter: function() {
                                return formatters.menu({title: i18n.contextMenuTitle});
                            }
                        }
                    }
                }),
                grid = this.grid = new SynonymGrid({
                    "class": "epi-plain-grid epi-plain-grid--no-border",
                    store: self.store,
                    noDataMessage: i18n.noSynonyms,
                    loadingMessage: i18n.dataLoading,
                    showLoadingMessage: true,
                    sort: [{attribute: "phrase", descending: false}]
                }, this.synonymGrid);

            this.own(grid,
                grid.on("dgrid-error", function(event) {
                    grid.showErrorInGrid(event.error);
                }),
                this.searchNode.watch("value", function(name, oldValue, newValue) {
                    self._searchText = newValue;
                    self._delayedReload();
                })
            );

            grid.contextMenu.addChild(new MenuItem({
                label: i18n.edit,
                onClick: function() {
                    var row = grid.getRow(this);
                    self._synonymForm.edit(row.id);
                }
            }));
            grid.contextMenu.addChild(new MenuItem({
                label: i18n["delete"],
                onClick: function() {
                    var row = grid.getRow(this);
                    self.showConfirmation({
                        title: i18n.deleteSynonym,
                        message: i18n.areYouSure,
                        confirmActionText: i18n.buttons_confirmDelete,
                        cancelActionText: i18n.buttons_cancelDelete,
                        action: function() {
                            when(self.store.remove(row.id),
                                function() {
                                    self.showSuccess(i18n.deletedMessage);
                                },
                                function(error) {
                                    self.showError(error);
                                    self.grid.refresh();
                                }
                            );
                        }
                    });
                }
            }));
        },

        _delayedReload: function() {
            //  summary:
            //      Updates grids query with text from the search textbox with delay.
            if (this._searchUpdateTimer) {
                clearTimeout(this._searchUpdateTimer);
            }
            this._searchUpdateTimer = setTimeout(lang.hitch(this, function () {
                this._searchUpdateTimer = null;
                this.grid.set("query", this._searchText ? {q: "(@ |\"\")" + this._searchText.toLowerCase() + ".*"} : {});
            }), this._searchUpdateTimeout);
        },

        startup: function() {
            this.inherited(arguments);
            var scrollNode = this.scrollNode || this.domNode.parentNode;
            this.grid.set("scrollNode", scrollNode);
            this.grid.startup();

            this.own(
                new StickyContainer({
                    scrollNode: scrollNode,
                    stickers: [
                        new Sticker({ domNode: this.synonymsHeader, offset: {top: 0}, limitNode: this.grid.domNode, subscribe: false}),
                        new Sticker({ domNode: this.grid.headerNode, offset: {top: 0}, limitNode: this.grid.domNode, subscribe: false})
                    ]
                })
            );
        }
    });
});
