define("epi-find/widget/_SwoshPaneBase", [
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",

    "dijit/layout/ContentPane",

    "./_StyleFocusMixin"

],
function(declare, domClass, domConstruct, domStyle,
    ContentPane,
    _StyleFocusMixin
) {
    // module:
    //      epi-find/widget/_SwoshPaneBase

    // TODO: Perhaps we would like to destroy the entire subwidget? Enable this and make it configurable.

    return declare([ContentPane, _StyleFocusMixin], {
        // name: String
        //      The name of the pane, will be used to define the css class
        name: null,

        // i18n: object
        //      The i18n object which contains strings for the template
        i18n: null,

        // removedChildren: _WidgetBase[]
        //      Array to save references to children removed onBlur
        removedChildren: null,

        // location: String (left|right)
        //      If the swosh pane is located to the right or the left
        location: null,

        // scrollNode: DomNode
        //      Defines what DomNode of the widget that is interesting for connecting scroll listeners to
        scrollNode: null,

        constructor: function() {
            this.removedChildren = [];
        },

        buildRendering: function() {

            var original = this.domNode; // Keep reference to original domNode to place it inside containernode.
            this.domNode = domConstruct.toDom("<div tabindex\"0\" class=\"epi-pane  epi-pane--"+this.location+"\"><a class=\"epi-pane-selector\"><span class=\"epi-pane-selector__arrow\">›</span></a>");
            this.wrapperNode = domConstruct.toDom("<div class=\"epi-pane__content-wrapper\"><div class=\"epi-pane__header\"><h1>"+ (this.i18n && this.i18n.header ? this.i18n.header : "") +"</h1><p class=\"epi-pane__description\">"+ (this.i18n && this.i18n.description ? this.i18n.description : "") +"</p></div></div></div>");
            this.scrollNode = this.containerNode = domConstruct.toDom("<div class=\"epi-pane__content\"><p class=\"epi-pane__description\">"+ (this.i18n && this.i18n.description ? this.i18n.description : "") +"</p></div>");

            domConstruct.place(this.containerNode, this.wrapperNode);
            domConstruct.place(this.wrapperNode, this.domNode);
            if(original) {
                domConstruct.place(original, this.containerNode);
            }

            this.inherited(arguments);
        },

        postCreate: function() {
            this.inherited(arguments);

            if(this.name) {
                domClass.add(this.domNode, "epi-pane--"+this.name);
            }
        },

        showChildren: function () {
            while(this.removedChildren.length > 0) {
                this.addChild(this.removedChildren.shift());
            }
        },

        hideChildren: function() {
            while(this.getChildren().length > 0) {
                var child = this.getChildren()[0];
                this.removeChild(child);
                this.removedChildren.push(child);
            }
        }
    });
});